namespace SharpUtils
{
	public class MaxLengthQueue
	{
		private LinkedList list;
		private int length;

		public MaxLengthQueue(int length)
		{
			list = new LinkedList();
			this.length = length;
		}

		public object Enqueue(object item)
		{
			list.Append(item);

			if(list.Count > length)
			{
				return list.RemoveFirst();
			} 
			else
			{
				return null;
			}
		}

		/// <summary>
		/// The linked list containing the data
		/// </summary>
		public LinkedList List
		{
			get
			{
				return list;
			}
		}

		/// <summary>
		/// Maximum Length of the Queue
		/// </summary>
		public int Length
		{
			get
			{
				return length;
			}
			set
			{
				length = value;
				while(list.Count > length)
				{
					list.RemoveFirst();
				}
			}
		}

		public int Count 
		{
			get
			{
				return list.Count;
			}
		}
	}
}
