/*
 * VC820Tool
 * Copyright (c) 2004 by Andreas Schroeder <andreas@a-netz.de>
 *
 * This file is part of VC820Tool.
 *
 * VC820Tool is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * VC820Tool is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with VC820Tool; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

using System;

namespace VC820Tool
{
	/// <summary>
	/// This interface has to be implemented by a control of a datagram 
	/// source. 
	/// </summary>
	public abstract class ControllingGui : System.Windows.Forms.UserControl
	{
		/// <summary>
		/// Apply the settings made in the control to the datagram source
		/// </summary>
		public abstract void ApplySettings();

		/// <summary>
		/// reset the settings made in the gui to the settings of the 
		/// datagram source to the values currently in use
		/// </summary>
		public abstract void ResetSettings();
	}
}
