using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace VC820Tool.Processors
{
	/// <summary>
	/// Zusammenfassung fr DataList.
	/// </summary>
	public class DataList : UI.BaseForm, IDatagramProcessor
	{
		private System.Windows.Forms.ListView lstValues;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.ColumnHeader chDateTime;
		private System.Windows.Forms.ColumnHeader chValue;
		private System.Windows.Forms.NumericUpDown nudItems;
		private System.Windows.Forms.Button btClear;
		private System.Windows.Forms.ColumnHeader chUnit;
		private System.ComponentModel.Container components = null;

		public DataList()
		{
			InitializeComponent();
		}

		/// <summary>
		/// Die verwendeten Ressourcen bereinigen.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Vom Windows Form-Designer generierter Code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			this.lstValues = new System.Windows.Forms.ListView();
			this.chDateTime = new System.Windows.Forms.ColumnHeader();
			this.chValue = new System.Windows.Forms.ColumnHeader();
			this.label1 = new System.Windows.Forms.Label();
			this.nudItems = new System.Windows.Forms.NumericUpDown();
			this.btClear = new System.Windows.Forms.Button();
			this.chUnit = new System.Windows.Forms.ColumnHeader();
			((System.ComponentModel.ISupportInitialize)(this.nudItems)).BeginInit();
			this.SuspendLayout();
			// 
			// lstValues
			// 
			this.lstValues.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.lstValues.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																						this.chDateTime,
																						this.chValue,
																						this.chUnit});
			this.lstValues.FullRowSelect = true;
			this.lstValues.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable;
			this.lstValues.Location = new System.Drawing.Point(8, 40);
			this.lstValues.Name = "lstValues";
			this.lstValues.Size = new System.Drawing.Size(512, 280);
			this.lstValues.TabIndex = 0;
			this.lstValues.View = System.Windows.Forms.View.Details;
			// 
			// chDateTime
			// 
			this.chDateTime.Text = "Date / Time";
			this.chDateTime.Width = 120;
			// 
			// chValue
			// 
			this.chValue.Text = "Value";
			this.chValue.Width = 120;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 10);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(40, 16);
			this.label1.TabIndex = 2;
			this.label1.Text = "Items";
			// 
			// nudItems
			// 
			this.nudItems.Increment = new System.Decimal(new int[] {
																	   5,
																	   0,
																	   0,
																	   0});
			this.nudItems.Location = new System.Drawing.Point(48, 8);
			this.nudItems.Maximum = new System.Decimal(new int[] {
																	 200,
																	 0,
																	 0,
																	 0});
			this.nudItems.Minimum = new System.Decimal(new int[] {
																	 1,
																	 0,
																	 0,
																	 0});
			this.nudItems.Name = "nudItems";
			this.nudItems.TabIndex = 3;
			this.nudItems.Value = new System.Decimal(new int[] {
																   20,
																   0,
																   0,
																   0});
			// 
			// btClear
			// 
			this.btClear.Location = new System.Drawing.Point(184, 8);
			this.btClear.Name = "btClear";
			this.btClear.TabIndex = 4;
			this.btClear.Text = "Clear List";
			this.btClear.Click += new System.EventHandler(this.btClear_Click);
			// 
			// chUnit
			// 
			this.chUnit.Text = "Unit";
			this.chUnit.Width = 80;
			// 
			// DataList
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(528, 325);
			this.Controls.Add(this.btClear);
			this.Controls.Add(this.nudItems);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.lstValues);
			this.Name = "DataList";
			this.Text = "DataList";
			((System.ComponentModel.ISupportInitialize)(this.nudItems)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		#region IDatagramProcessor Member

		public void OnDatagram(Datagram dgram)
		{
			while(lstValues.Items.Count >= nudItems.Value)
			{
				lstValues.Items.RemoveAt(0);
			}

			ListViewItem item = lstValues.Items.Add(dgram.Timestamp.ToString("dd.MM.yyyy hh:mm:ss"));
			item.SubItems.Add(string.Format("{0:0.000}", dgram.RealValue));
			item.SubItems.Add(Datagram.GetUnitName(dgram.Unit));
		}

		private void btClear_Click(object sender, System.EventArgs e)
		{
			lstValues.Items.Clear();
		}

		public string UIName
		{
			get
			{
				return "Data List";
			}
		}

		public string InternalName
		{
			get
			{
				return "DataList";
			}
		}

		public VC820Tool.UI.BaseForm UserInterface
		{
			get
			{
				return this;
			}
		}

		#endregion
	}
}
