using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Threading;
using System.Runtime.InteropServices;

namespace VC820Tool.Processors
{


	/// <summary>
	/// Zusammenfassung fr DeltaPeakCharger.
	/// </summary>
	public class DeltaPeakCharger : UI.BaseForm, IDatagramProcessor
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Button btReset;
		private System.Windows.Forms.Label laPercent;
		private System.Windows.Forms.Label laVoltage;
		private System.Windows.Forms.Label laTime;
		/// <summary>
		/// Erforderliche Designervariable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Label laState;
		private System.Windows.Forms.Label label5;

		private DateTime starttime;
		private System.Windows.Forms.TextBox txtCapacity;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.TextBox txtCurrent;

		private ChargeStateEnum state = ChargeStateEnum.StartWait;
		private DateTime endtime;
		private int current;
		private int capacity;
		private Thread alarmthread = null;
		private SharpUtils.MaxLengthQueue queue;
		private System.Windows.Forms.Label label9;
		private System.Windows.Forms.Label laAverage;
		private System.Windows.Forms.Label laDelta;
		private System.Windows.Forms.Label label10;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.NumericUpDown nudAvgCount;

		[DllImport("kernel32.dll")] public extern static System.UInt32 Beep(
			System.UInt32 freq, System.UInt32 length);

		public DeltaPeakCharger()
		{
			InitializeComponent();
			queue = new SharpUtils.MaxLengthQueue(10);
		}

		/// <summary>
		/// Die verwendeten Ressourcen bereinigen.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Vom Windows Form-Designer generierter Code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.btReset = new System.Windows.Forms.Button();
			this.laPercent = new System.Windows.Forms.Label();
			this.laVoltage = new System.Windows.Forms.Label();
			this.laTime = new System.Windows.Forms.Label();
			this.laState = new System.Windows.Forms.Label();
			this.label5 = new System.Windows.Forms.Label();
			this.txtCapacity = new System.Windows.Forms.TextBox();
			this.label4 = new System.Windows.Forms.Label();
			this.label6 = new System.Windows.Forms.Label();
			this.txtCurrent = new System.Windows.Forms.TextBox();
			this.laAverage = new System.Windows.Forms.Label();
			this.label9 = new System.Windows.Forms.Label();
			this.laDelta = new System.Windows.Forms.Label();
			this.label10 = new System.Windows.Forms.Label();
			this.label7 = new System.Windows.Forms.Label();
			this.nudAvgCount = new System.Windows.Forms.NumericUpDown();
			((System.ComponentModel.ISupportInitialize)(this.nudAvgCount)).BeginInit();
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(16, 184);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(100, 16);
			this.label1.TabIndex = 0;
			this.label1.Text = "Charging Time";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(16, 160);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(100, 16);
			this.label2.TabIndex = 1;
			this.label2.Text = "Voltage [V]";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(16, 136);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(100, 16);
			this.label3.TabIndex = 2;
			this.label3.Text = "Charged";
			// 
			// btReset
			// 
			this.btReset.Location = new System.Drawing.Point(8, 8);
			this.btReset.Name = "btReset";
			this.btReset.TabIndex = 3;
			this.btReset.Text = "Reset";
			this.btReset.Click += new System.EventHandler(this.btReset_Click);
			// 
			// laPercent
			// 
			this.laPercent.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.laPercent.Location = new System.Drawing.Point(128, 136);
			this.laPercent.Name = "laPercent";
			this.laPercent.Size = new System.Drawing.Size(96, 16);
			this.laPercent.TabIndex = 4;
			this.laPercent.Text = "0 %";
			this.laPercent.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// laVoltage
			// 
			this.laVoltage.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.laVoltage.Location = new System.Drawing.Point(128, 160);
			this.laVoltage.Name = "laVoltage";
			this.laVoltage.Size = new System.Drawing.Size(96, 16);
			this.laVoltage.TabIndex = 5;
			this.laVoltage.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// laTime
			// 
			this.laTime.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.laTime.Location = new System.Drawing.Point(128, 184);
			this.laTime.Name = "laTime";
			this.laTime.Size = new System.Drawing.Size(96, 16);
			this.laTime.TabIndex = 6;
			this.laTime.Text = "0:00";
			this.laTime.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// laState
			// 
			this.laState.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.laState.Location = new System.Drawing.Point(128, 272);
			this.laState.Name = "laState";
			this.laState.Size = new System.Drawing.Size(96, 16);
			this.laState.TabIndex = 7;
			this.laState.Text = "Not Charging";
			this.laState.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(16, 272);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(100, 16);
			this.label5.TabIndex = 8;
			this.label5.Text = "State";
			// 
			// txtCapacity
			// 
			this.txtCapacity.Location = new System.Drawing.Point(128, 80);
			this.txtCapacity.Name = "txtCapacity";
			this.txtCapacity.Size = new System.Drawing.Size(96, 20);
			this.txtCapacity.TabIndex = 9;
			this.txtCapacity.Text = "0";
			this.txtCapacity.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(16, 80);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(112, 16);
			this.label4.TabIndex = 10;
			this.label4.Text = "Accu Capacity [mAh]";
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(16, 56);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(100, 16);
			this.label6.TabIndex = 11;
			this.label6.Text = "Current [mA]";
			// 
			// txtCurrent
			// 
			this.txtCurrent.Location = new System.Drawing.Point(128, 56);
			this.txtCurrent.Name = "txtCurrent";
			this.txtCurrent.Size = new System.Drawing.Size(96, 20);
			this.txtCurrent.TabIndex = 12;
			this.txtCurrent.Text = "0";
			this.txtCurrent.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			// 
			// laAverage
			// 
			this.laAverage.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.laAverage.Location = new System.Drawing.Point(128, 208);
			this.laAverage.Name = "laAverage";
			this.laAverage.Size = new System.Drawing.Size(96, 16);
			this.laAverage.TabIndex = 15;
			this.laAverage.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// label9
			// 
			this.label9.Location = new System.Drawing.Point(16, 208);
			this.label9.Name = "label9";
			this.label9.Size = new System.Drawing.Size(100, 16);
			this.label9.TabIndex = 16;
			this.label9.Text = "Average [V]";
			// 
			// laDelta
			// 
			this.laDelta.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.laDelta.Location = new System.Drawing.Point(128, 232);
			this.laDelta.Name = "laDelta";
			this.laDelta.Size = new System.Drawing.Size(96, 16);
			this.laDelta.TabIndex = 15;
			this.laDelta.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// label10
			// 
			this.label10.Location = new System.Drawing.Point(16, 232);
			this.label10.Name = "label10";
			this.label10.Size = new System.Drawing.Size(100, 16);
			this.label10.TabIndex = 16;
			this.label10.Text = "Delta [V]";
			// 
			// label7
			// 
			this.label7.Location = new System.Drawing.Point(16, 104);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(72, 16);
			this.label7.TabIndex = 17;
			this.label7.Text = "Avg Count";
			// 
			// nudAvgCount
			// 
			this.nudAvgCount.Location = new System.Drawing.Point(128, 104);
			this.nudAvgCount.Name = "nudAvgCount";
			this.nudAvgCount.Size = new System.Drawing.Size(96, 20);
			this.nudAvgCount.TabIndex = 18;
			this.nudAvgCount.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.nudAvgCount.Value = new System.Decimal(new int[] {
																	  10,
																	  0,
																	  0,
																	  0});
			// 
			// DeltaPeakCharger
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(240, 301);
			this.Controls.Add(this.nudAvgCount);
			this.Controls.Add(this.label7);
			this.Controls.Add(this.label9);
			this.Controls.Add(this.laAverage);
			this.Controls.Add(this.txtCurrent);
			this.Controls.Add(this.txtCapacity);
			this.Controls.Add(this.label6);
			this.Controls.Add(this.label4);
			this.Controls.Add(this.label5);
			this.Controls.Add(this.laState);
			this.Controls.Add(this.laTime);
			this.Controls.Add(this.laVoltage);
			this.Controls.Add(this.laPercent);
			this.Controls.Add(this.btReset);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.laDelta);
			this.Controls.Add(this.label10);
			this.Name = "DeltaPeakCharger";
			this.Text = "DeltaPeakCharger";
			((System.ComponentModel.ISupportInitialize)(this.nudAvgCount)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion
	
		#region IDatagramProcessor Member

		public void OnDatagram(Datagram dgram)
		{
			if(state == ChargeStateEnum.StartWait) 
			{
				current = Convert.ToInt32(txtCurrent.Text);
				capacity = Convert.ToInt32(txtCapacity.Text);
				starttime = DateTime.Now;

				state = ChargeStateEnum.Charging;
			}
			
			queue.Enqueue(dgram.RealValue);

			DetectFinish(dgram);

			DisplayValues(dgram);
		}

		private void Reset()
		{
			state = ChargeStateEnum.StartWait;
			if(alarmthread != null)
				alarmthread.Abort();
			alarmthread = null;

			queue.Length = (int) nudAvgCount.Value;
			DisplayValues(null);
		}

		private void btReset_Click(object sender, System.EventArgs e)
		{
			Reset();
		}

		public string UIName
		{
			get
			{
				return "Delta Peak Charger";
			}
		}

		public string InternalName
		{
			get
			{
				return "DPCharger";
			}
		}

		public UI.BaseForm UserInterface
		{
			get
			{				
				return this;
			}
		}
		#endregion

		private void DisplayValues(Datagram dgram)
		{
			TimeSpan span;
			if(dgram != null)
				laVoltage.Text = dgram.RealValue.ToString("0.00");

			switch(state)
			{
				case ChargeStateEnum.StartWait:
					laState.Text = "Waiting for Start";
					break;

				case ChargeStateEnum.Charging:
					span = DateTime.Now - starttime;
					laTime.Text = span.ToString();

					laState.Text = "Charging";
					if(capacity > 0 && current > 0)
                        laPercent.Text = ((double)(capacity / current) * span.TotalHours * 100).ToString("0.00") + "%";

					break;

				case ChargeStateEnum.Finished:
					span = endtime - starttime;
					laTime.Text = span.ToString();

					laState.Text = "Finished";
					break;
			}
		}
		
		private void DetectFinish(Datagram dgram)
		{
			double avg = 0;

			foreach(decimal val in queue.List)
			{
				avg += (double) val;
			}

			avg /= queue.Count;

			laAverage.Text = avg.ToString("0.000");

			double delta = (double)dgram.RealValue - avg;
			
			laDelta.Text = delta.ToString("0.000");

			if(state == ChargeStateEnum.Charging)
			{
				if(delta < -0.01)
				{
					state = ChargeStateEnum.Finished;
					endtime = DateTime.Now;
					OnFinished();
				}
			}
		}

		protected void OnFinished()
		{
			alarmthread = new Thread(new ThreadStart(DoAlarm));
			alarmthread.Name = "Charge-Alarm";
			alarmthread.IsBackground = true;
			alarmthread.Start();
		}

		protected void DoAlarm()
		{
			while(true)
			{
				Thread.Sleep(300);
				DeltaPeakCharger.Beep(880, 100);
			}
		}
	}

	public enum ChargeStateEnum 
	{
		Charging,
		StartWait, 
		Finished
	}
}
