/*
 * VC820Tool
 * Copyright (c) 2004 by Andreas Schroeder <andreas@a-netz.de>
 *
 * This file is part of VC820Tool.
 *
 * VC820Tool is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * VC820Tool is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with VC820Tool; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace VC820Tool.Processors
{
	/// <summary>
	/// Summary description for TextOutputForm.
	/// </summary>
	public class TextOutputForm : UI.BaseForm, IDatagramProcessor
	{
		private System.Windows.Forms.CheckBox cbBeep;
		private System.Windows.Forms.CheckBox cbHold;
		private System.Windows.Forms.CheckBox cbDiode;
		private System.Windows.Forms.CheckBox cbTrueRms;
		private System.Windows.Forms.CheckBox cbDelta;
		private System.Windows.Forms.CheckBox cbAC;
		private System.Windows.Forms.CheckBox cbRS232;
		private System.Windows.Forms.CheckBox cbAuto;
		private System.Windows.Forms.Label laUnit;
		private System.Windows.Forms.Label laValue;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public TextOutputForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.cbBeep = new System.Windows.Forms.CheckBox();
			this.cbHold = new System.Windows.Forms.CheckBox();
			this.cbDiode = new System.Windows.Forms.CheckBox();
			this.cbTrueRms = new System.Windows.Forms.CheckBox();
			this.cbDelta = new System.Windows.Forms.CheckBox();
			this.cbAC = new System.Windows.Forms.CheckBox();
			this.cbRS232 = new System.Windows.Forms.CheckBox();
			this.cbAuto = new System.Windows.Forms.CheckBox();
			this.laUnit = new System.Windows.Forms.Label();
			this.laValue = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// cbBeep
			// 
			this.cbBeep.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left);
			this.cbBeep.AutoCheck = false;
			this.cbBeep.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.cbBeep.Location = new System.Drawing.Point(144, 120);
			this.cbBeep.Name = "cbBeep";
			this.cbBeep.Size = new System.Drawing.Size(104, 16);
			this.cbBeep.TabIndex = 12;
			this.cbBeep.Text = "Beep";
			// 
			// cbHold
			// 
			this.cbHold.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left);
			this.cbHold.AutoCheck = false;
			this.cbHold.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.cbHold.Location = new System.Drawing.Point(144, 136);
			this.cbHold.Name = "cbHold";
			this.cbHold.Size = new System.Drawing.Size(104, 16);
			this.cbHold.TabIndex = 10;
			this.cbHold.Text = "Hold";
			// 
			// cbDiode
			// 
			this.cbDiode.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left);
			this.cbDiode.AutoCheck = false;
			this.cbDiode.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.cbDiode.Location = new System.Drawing.Point(144, 88);
			this.cbDiode.Name = "cbDiode";
			this.cbDiode.Size = new System.Drawing.Size(104, 16);
			this.cbDiode.TabIndex = 9;
			this.cbDiode.Text = "Diode";
			// 
			// cbTrueRms
			// 
			this.cbTrueRms.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left);
			this.cbTrueRms.AutoCheck = false;
			this.cbTrueRms.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.cbTrueRms.Location = new System.Drawing.Point(8, 136);
			this.cbTrueRms.Name = "cbTrueRms";
			this.cbTrueRms.Size = new System.Drawing.Size(96, 16);
			this.cbTrueRms.TabIndex = 8;
			this.cbTrueRms.Text = "True RMS";
			// 
			// cbDelta
			// 
			this.cbDelta.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left);
			this.cbDelta.AutoCheck = false;
			this.cbDelta.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.cbDelta.Location = new System.Drawing.Point(144, 104);
			this.cbDelta.Name = "cbDelta";
			this.cbDelta.Size = new System.Drawing.Size(104, 16);
			this.cbDelta.TabIndex = 7;
			this.cbDelta.Text = "Delta";
			// 
			// cbAC
			// 
			this.cbAC.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left);
			this.cbAC.AutoCheck = false;
			this.cbAC.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.cbAC.Location = new System.Drawing.Point(8, 120);
			this.cbAC.Name = "cbAC";
			this.cbAC.Size = new System.Drawing.Size(96, 16);
			this.cbAC.TabIndex = 6;
			this.cbAC.Text = "AC";
			// 
			// cbRS232
			// 
			this.cbRS232.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left);
			this.cbRS232.AutoCheck = false;
			this.cbRS232.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.cbRS232.Location = new System.Drawing.Point(8, 104);
			this.cbRS232.Name = "cbRS232";
			this.cbRS232.Size = new System.Drawing.Size(96, 16);
			this.cbRS232.TabIndex = 5;
			this.cbRS232.Text = "RS-232";
			// 
			// cbAuto
			// 
			this.cbAuto.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left);
			this.cbAuto.AutoCheck = false;
			this.cbAuto.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.cbAuto.Location = new System.Drawing.Point(8, 88);
			this.cbAuto.Name = "cbAuto";
			this.cbAuto.Size = new System.Drawing.Size(96, 16);
			this.cbAuto.TabIndex = 4;
			this.cbAuto.Text = "Auto";
			// 
			// laUnit
			// 
			this.laUnit.Anchor = ((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.laUnit.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.laUnit.Location = new System.Drawing.Point(8, 64);
			this.laUnit.Name = "laUnit";
			this.laUnit.Size = new System.Drawing.Size(240, 23);
			this.laUnit.TabIndex = 13;
			this.laUnit.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// laValue
			// 
			this.laValue.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.laValue.BackColor = System.Drawing.Color.White;
			this.laValue.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.laValue.Font = new System.Drawing.Font("Courier New", 26.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.laValue.Location = new System.Drawing.Point(8, 8);
			this.laValue.Name = "laValue";
			this.laValue.Size = new System.Drawing.Size(240, 48);
			this.laValue.TabIndex = 1;
			this.laValue.Text = "0,00";
			this.laValue.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			this.laValue.DoubleClick += new System.EventHandler(this.laValue_DoubleClick);
			// 
			// TextOutputForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(256, 157);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.laUnit,
																		  this.cbBeep,
																		  this.cbHold,
																		  this.cbDiode,
																		  this.cbTrueRms,
																		  this.cbDelta,
																		  this.cbAC,
																		  this.cbRS232,
																		  this.cbAuto,
																		  this.laValue});
			this.MinimumSize = new System.Drawing.Size(264, 160);
			this.Name = "TextOutputForm";
			this.ShowInTaskbar = false;
			this.Text = "Current Value";
			this.Load += new System.EventHandler(this.TextOutputForm_Load);
			this.ResumeLayout(false);

		}
		#endregion


		private void laValue_DoubleClick(object sender, System.EventArgs e)
		{
			Clipboard.SetDataObject(laValue.Text);
		}

		#region Implementation of IDatagramProcessor
		public void OnDatagram(Datagram dgram)
		{
			if(dgram.Overload)
			{
				laValue.Text = "OVERLOAD";
			}
			else
			{
				laValue.Text = dgram.Value.ToString();
			}

			laUnit.Text = "";
			if(dgram.Prefix != PrefixEnum.None)
				laUnit.Text = dgram.PrefixName + "-";
			
			
			laUnit.Text += Datagram.GetUnitName(dgram.Unit);

			cbAuto.Checked = dgram.Auto;
			cbRS232.Checked = dgram.RS232;
			cbAC.Checked = dgram.AC;
			cbTrueRms.Checked = dgram.TrueRms;
			cbDiode.Checked = dgram.Diode;
			cbHold.Checked = dgram.Hold;
			cbDelta.Checked = dgram.Delta;
			cbBeep.Checked = dgram.Beep;
		}

		private void TextOutputForm_Load(object sender, System.EventArgs e)
		{
		
		}

		public string UIName
		{
			get
			{
				return "Text View";
			}
		}

		public string InternalName
		{
			get
			{
				return "TextView";
			}
		}
		
		public UI.BaseForm UserInterface
		{
			get
			{
				return this;
			}
		}
		#endregion


	}
}
