/*
 * VC820Tool
 * Copyright (c) 2004 by Andreas Schroeder <andreas@a-netz.de>
 *
 * This file is part of VC820Tool.
 *
 * VC820Tool is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * VC820Tool is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with VC820Tool; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

namespace VC820Tool.Sources
{
	public class SerialSourceCtrl : ControllingGui
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.NumericUpDown nudPort;
		private System.ComponentModel.Container components = null;

		private SerialSource source;

		public SerialSourceCtrl(SerialSource _source)
		{
			InitializeComponent();

			source = _source;
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.nudPort = new System.Windows.Forms.NumericUpDown();
			this.label1 = new System.Windows.Forms.Label();
			((System.ComponentModel.ISupportInitialize)(this.nudPort)).BeginInit();
			this.SuspendLayout();
			// 
			// nudPort
			// 
			this.nudPort.Location = new System.Drawing.Point(48, 8);
			this.nudPort.Maximum = new System.Decimal(new int[] {
																	8,
																	0,
																	0,
																	0});
			this.nudPort.Minimum = new System.Decimal(new int[] {
																	1,
																	0,
																	0,
																	0});
			this.nudPort.Name = "nudPort";
			this.nudPort.Size = new System.Drawing.Size(56, 20);
			this.nudPort.TabIndex = 0;
			this.nudPort.Value = new System.Decimal(new int[] {
																  1,
																  0,
																  0,
																  0});
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.Location = new System.Drawing.Point(8, 10);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(32, 16);
			this.label1.TabIndex = 1;
			this.label1.Text = "Port";
			// 
			// SerialSourceCtrl
			// 
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.label1,
																		  this.nudPort});
			this.Name = "SerialSourceCtrl";
			this.Size = new System.Drawing.Size(144, 32);
			((System.ComponentModel.ISupportInitialize)(this.nudPort)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		public override void ApplySettings()
		{
			source.Port = (int) nudPort.Value;
		}

		public override void ResetSettings()
		{
			nudPort.Value = source.Port;
		}
	}
}
