/*
 * VC820Tool
 * Copyright (c) 2004 by Andreas Schroeder <andreas@a-netz.de>
 *
 * This file is part of VC820Tool.
 *
 * VC820Tool is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * VC820Tool is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with VC820Tool; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

namespace VC820Tool.UI
{
	public class DataFlasher : System.Windows.Forms.UserControl
	{
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Panel pnlFlash;
		private System.Timers.Timer timer;
		private Color orgcolor;

		public DataFlasher()
		{
			InitializeComponent();

			timer = new System.Timers.Timer();
			timer.Elapsed += new System.Timers.ElapsedEventHandler(this.OnTimer);
			timer.AutoReset = true;
			timer.Interval = 200;
			orgcolor = pnlFlash.BackColor;
		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.pnlFlash = new System.Windows.Forms.Panel();
			this.SuspendLayout();
			// 
			// pnlFlash
			// 
			this.pnlFlash.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.pnlFlash.Dock = System.Windows.Forms.DockStyle.Fill;
			this.pnlFlash.Name = "pnlFlash";
			this.pnlFlash.Size = new System.Drawing.Size(150, 150);
			this.pnlFlash.TabIndex = 0;
			// 
			// DataFlasher
			// 
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.pnlFlash});
			this.Name = "DataFlasher";
			this.ResumeLayout(false);

		}
		#endregion

		public void Flash()
		{
			if(pnlFlash.BackColor == Color.Red)
				pnlFlash.BackColor = Control.DefaultBackColor;
			else
				pnlFlash.BackColor = Color.Red;
			//timer.Start();
		}

		private void OnTimer(object sender, System.Timers.ElapsedEventArgs e)
		{
			pnlFlash.BackColor = orgcolor;
			timer.Stop();
		}

		public double FlashTime
		{
			get
			{
				return timer.Interval;
			}
			set
			{
				timer.Interval = value;
			}
		}

	}
}
