/*
 * VC820Tool
 * Copyright (c) 2004 by Andreas Schroeder <andreas@a-netz.de>
 *
 * This file is part of VC820Tool.
 *
 * VC820Tool is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * VC820Tool is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with VC820Tool; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

using System;

namespace VC820Tool.VDTrigger
{
	/// <summary>
	/// This interface has to be implemented by all DispatcherTriggers
	/// </summary>
	public interface IDispatcherTrigger
	{
		/// <summary>
		/// The dispatcher that should be controlled
		/// </summary>
		ValueDispatcher Dispatcher { get; set; }

		/// <summary>
		/// our name
		/// </summary>
		string Name { get;}

		/// <summary>
		/// A gui control to change settings of this trigger
		/// </summary>
		ControllingGui UserInterface { get; }

		/// <summary>
		/// Enable or disable this trigger
		/// </summary>
		bool Enable { get; set;	}
	}
}
