/*
 * VC820Tool
 * Copyright (c) 2004 by Andreas Schroeder <andreas@a-netz.de>
 *
 * This file is part of VC820Tool.
 *
 * VC820Tool is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * VC820Tool is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with VC820Tool; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

using System;
using System.Windows.Forms;

namespace VC820Tool.VDTrigger
{
	public class InstrumentVDTrigger : AbstractVDTrigger
	{
		public InstrumentVDTrigger()
		{
			ctrl = null;
		}

		public void OnNewDatagram(Sources.IDatagramSource source, Datagram dgram)
		{
			if(m_enabled)
			{
				vd.Trigger();
			}
		}

		public override string Name
		{
			get
			{
				return "Instrument";
			}
		}

		public override bool Enable
		{
			get
			{
				return m_enabled;
			}
			set
			{
				m_enabled = value;
			}
		}

//		public override void ApplySettings()
//		{
//			// nothing to do here
//		}
//
//		public override void ResetSettings()
//		{
//			// nothing to do here
//		}
	}
}
