/*
 * VC820Tool
 * Copyright (c) 2004 by Andreas Schroeder <andreas@a-netz.de>
 *
 * This file is part of VC820Tool.
 *
 * VC820Tool is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * VC820Tool is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with VC820Tool; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

namespace VC820Tool.VDTrigger
{
	public class SingleShotVDTriggerCtrl : ControllingGui
	{
		private System.Windows.Forms.Button btSingleShot;
		private System.ComponentModel.Container components = null;

		private SingleShotVDTrigger trigger;

		public SingleShotVDTriggerCtrl(SingleShotVDTrigger _trigger)
		{
			InitializeComponent();
			
			trigger = _trigger;
		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.btSingleShot = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// btSingleShot
			// 
			this.btSingleShot.BackColor = System.Drawing.SystemColors.Control;
			this.btSingleShot.Location = new System.Drawing.Point(8, 8);
			this.btSingleShot.Name = "btSingleShot";
			this.btSingleShot.Size = new System.Drawing.Size(112, 23);
			this.btSingleShot.TabIndex = 7;
			this.btSingleShot.Text = "Take Value";
			this.btSingleShot.Click += new System.EventHandler(this.btSingleShot_Click);
			// 
			// SingleShotDispatcherTriggerCtrl
			// 
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.btSingleShot});
			this.Name = "SingleShotDispatcherTriggerCtrl";
			this.ResumeLayout(false);

		}
		#endregion

		private void btSingleShot_Click(object sender, System.EventArgs e)
		{
			trigger.DoSingleShot();
		}

		public override void ApplySettings()
		{
			// nothing to be done here
		}

		public override void ResetSettings()
		{
			// nothing to be done here
		}


	}
}
