/*
 * VC820Tool
 * Copyright (c) 2004 by Andreas Schroeder <andreas@a-netz.de>
 *
 * This file is part of VC820Tool.
 *
 * VC820Tool is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * VC820Tool is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with VC820Tool; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

namespace VC820Tool.VDTrigger
{
	/// <summary>
	/// Summary description for TimerDispatcherTriggerCtrl.
	/// </summary>
	public class TimerVDTriggerCtrl : ControllingGui
	{
		private System.Windows.Forms.TextBox txtInterval;
		private System.Windows.Forms.Label label1;
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		private TimerVDTrigger trigger;

		public TimerVDTriggerCtrl(TimerVDTrigger _trigger)
		{
			InitializeComponent();

			trigger = _trigger;
			trigger.Interval = Settings.CM.GetInt("/VDTrigger/Timer/DefaultInterval", 2000);
			ResetSettings();
		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.txtInterval = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// txtInterval
			// 
			this.txtInterval.Location = new System.Drawing.Point(16, 24);
			this.txtInterval.Name = "txtInterval";
			this.txtInterval.Size = new System.Drawing.Size(64, 20);
			this.txtInterval.TabIndex = 5;
			this.txtInterval.Text = "5000";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(72, 16);
			this.label1.TabIndex = 7;
			this.label1.Text = "Interval [ms]";
			// 
			// TimerDispatcherTriggerCtrl
			// 
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.txtInterval,
																		  this.label1});
			this.Name = "TimerDispatcherTriggerCtrl";
			this.Size = new System.Drawing.Size(168, 64);
			this.ResumeLayout(false);

		}
		#endregion

		public override void ApplySettings()
		{
			trigger.Interval = Convert.ToDouble(txtInterval.Text);
		}

		public override void ResetSettings()
		{
			txtInterval.Text = trigger.Interval.ToString();
		}
	}
}
